# std::filesystem::path::generic_string, std::filesystem::path::generic_wstring, std::filesystem::path::generic_u8string, std::filesystem::path::generic_u16string, std::filesystem::path::generic_u32string

From cppreference.com
< cpp‎ | filesystem‎ | path

template< class CharT, class Traits = std::char_traits<CharT>, class Alloc = std::allocator<CharT> > std::basic_string<CharT,Traits,Alloc> generic_string( const Alloc& a = Alloc() ) const; | (1) | (since C++17)
| (2) | (since C++17)
std::string generic_string() const; |  |
std::wstring generic_wstring() const; |  |
std::u16string generic_u16string() const; |  |
std::u32string generic_u32string() const; |  |
| (3) |
std::string generic_u8string() const; |  | (since C++17) (until C++20)
std::u8string generic_u8string() const; |  | (since C++20)

Returns the internal pathname in generic pathname format, converted to specific string type. Conversion, if any, is specified as follows:

- If `path::value_type` is char, conversion, if any, is system-dependent. This is the case on typical POSIX systems (such as Linux), where native encoding is UTF-8 and `string()` performs no conversion.
- Otherwise, if `path::value_type` is wchar_t, conversion, if any, is unspecified. This is the case on Windows, where wchar_t is 16 bit and the native encoding is UTF-16.
- Otherwise, if `path::value_type` is char16_t, native encoding is UTF-16 and the conversion method is unspecified.
- Otherwise, if `path::value_type` is char32_t, native encoding is UTF-32 and the conversion method is unspecified.
- Otherwise, if `path::value_type` is char8_t, native encoding is UTF-8 and the conversion method is unspecified.

The `/` character is used as the directory separator.

1) All memory allocations are performed by `a`.
3) The result encoding in the case of `u8string()` is always UTF-8.

### Parameters

a | - | allocator to construct the string with
Type requirements
- `CharT` must be one of the encoded character types (char, wchar_t, char16_t and char32_t)

### Return value

The internal pathname in generic pathname format, converted to specified string type.

### Exceptions

(none)

### See also

string wstring u8string u16string u32string | returns the path in native pathname format converted to a string (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/filesystem/path/generic_string&oldid=108102"